* ----------------------------------------------------------------- SMCWinno
      Program SMCWinno

* Reads a list of files and writes a subset of this list to a file.
* The subset contains a specified string.  This program can be used in
* combination with a dos dir/on/b command to generate a list of
* file names to be used as input into programs for which only the subset
* is needed.

* Sample control file:
* Control file for program SMCWinno
* Name of output file:
*  smcwinno.lst
* String to use in winnowing files:
*  _a.smc
* List of files to winnow:
*  0516a_a.smc
*  0516a_d.smc
*  0516a_u.smc
*  0516a_v.smc
*  0517a_a.smc
*  0517a_d.smc
*  0517a_u.smc
*  0517a_v.smc
* StoP

* Dates: 12/22/00 - Written by D. Boore


      character f_ctl*40, f_out*40, 
     :  string_winnow*40, string_in*80
      logical f_ctl_exist

      f_ctl_exist = .false.
      do while (.not. f_ctl_exist)
        f_ctl = ' '
        write(*, '(a\)') 
     :    ' Enter name of control file (cr to quit): '
        read(*, '(a)') f_ctl
        if (f_ctl .eq. ' ') stop
        inquire(file=f_ctl, exist=f_ctl_exist)
        if (.not. f_ctl_exist) then
          write(*,'(a)') ' ******* FILE DOES NOT EXIST ******* '
        end if
      end do

      call get_lun(nu_ctl)
      open(unit=nu_ctl,file=f_ctl,status='unknown')

      call skip(nu_ctl,2)

      f_out = ' '
      read(nu_ctl,'(a)') f_out
      call get_lun(nu_out)
      open(unit=nu_out,file=f_out,status='unknown')

      call skip(nu_ctl,1)

      string_winnow = ' '
      read(nu_ctl,'(a)') string_winnow
      call upstr(string_winnow)
      call trim_c(string_winnow, nc_sw)
      write(*,'(2a)') ' String_winnow = ', string_winnow(1:nc_sw)
      
      call skip(nu_ctl,1)

1000  continue

      string_in = ' '
      read(nu_ctl,'(a)') string_in
      call upstr(string_in)
      call trim_c(string_in, nc_in)
      if(string_in(1:4) .eq. 'STOP') then
        close(nu_out)
        close(nu_ctl)
        stop
      end if

      iws = index(string_in(1:nc_in),string_winnow(1:nc_sw))
      if (iws .ne. 0) then
         write(nu_out,'(a)') string_in(1:nc_in)
      end if
      
      go to 1000     
     
      end
* ----------------------------------------------------------------- SMCWinno

      include '\forprogs\skip.for'
      include '\forprogs\upstr.for'
      include '\forprogs\trim_c.for'
      include '\forprogs\get_lun.for'
