      Program Normal_probability_plot_prep
      
*!Control file for program normal_probability_plot_prep
*!Date control file modified:
* 02/11/11
*!File containing a column of numbers for which a normal
*! probability plot is to be made
*   kik-net_vavg(30)_savg(30).txt
*!Number of headers before data
* 1
*!Number of column containing data to use:
* 3
*! 4
*!Null value
* -9.99
*!Output file name:
* kik-net_vavg(30)_for_probability_plot.out
*! kik-net_savg(30)_for_probability_plot.out

! Dates: 08/04/10 - Written by D. Boore
!        02/11/11 - Added null value

      real data(50000), work(50000), rank(50000)
      real data_theory(50000)
      
      real invnorm
      
      integer status
      
      character buf*200, buf4*4, 
     :   f_ctl*200, f_in*200, f_out*200
      
      character version_ctl*8, version_in*30

      character cmnts2skip(50)*80

      logical f_exist, f_a_exist, rmv_trnd, use_v0_d0

      f_exist = .false.
      do while (.not. f_exist)
        f_ctl = ' '
        write(*, '(a\)') 
     :    ' Enter name of control file '//
     :    '(cr=Normal_probability_plot_prep.ctl;'//
     :    ' ctl-brk to quit): '
        read(*, '(a)') f_ctl
        if (f_ctl(1:4) .eq. '    ') 
     :     f_ctl = 'Normal_probability_plot_prep.ctl'
        call trim_c(f_ctl, nc_f_ctl)
        inquire(file=f_ctl(1:nc_f_ctl), exist=f_exist)
        if (.not. f_exist) then
          write(*,'(a)') ' ******* FILE DOES NOT EXIST ******* '
        end if
      end do

      call get_lun(nu_ctl)
      open(unit=nu_ctl,file=f_ctl(1:nc_f_ctl),status='unknown')

*Check version of control file
      version_ctl = ' '
      version_ctl = '02/11/11'
      call trim_c(version_ctl,nc_version_ctl)

      call skipcmnt(nu_ctl,cmnts2skip, nc_comments)
      version_in = ' '
      read(nu_ctl,'(a)') version_in
      call trim_c(version_in,nc_version_in)
      
      if (version_ctl(1:nc_version_ctl) /=
     :    version_in(1:nc_version_in)) then
        write(*,'(a)') 
     :     ' The control file has the wrong version date; STOP!'
        close(nu_ctl)
        stop
      end if
      
      call skipcmnt(nu_ctl,cmnts2skip, nc_comments)
      f_in = ' '
      read(nu_ctl,'(a)') f_in
      call trim_c(f_in,nc_f_in)
      call skipcmnt(nu_ctl,cmnts2skip, nc_comments)
      read(nu_ctl,*) nheaders      
      
      call skipcmnt(nu_ctl,cmnts2skip, nc_comments)
      read(nu_ctl,*) ncol4data     

      call skipcmnt(nu_ctl,cmnts2skip, nc_comments)
      read(nu_ctl,*) ynull     

      call skipcmnt(nu_ctl,cmnts2skip, nc_comments)
      f_out = ' '
      read(nu_ctl,'(a)') f_out
      call trim_c(f_out,nc_f_out)
      call get_lun(nu_out)
      open(nu_out,f_out(1:nc_f_out),status='unknown')
      
      close(nu_ctl)

! Read data      
      call get_lun(nu_in)
      open(nu_in,f_in(1:nc_f_in),status='unknown')
      
      call skip(nu_in, nheaders)
      
      ndata = 0
      
      loop over data: DO
      
        buf = ' '
        read(nu_in,'(a)',iostat=status) buf
        
        if (status /= 0) then
          close(nu_in)
          EXIT loop over data
        end if
        
        call trim_c(buf, nc_buf)
        buf4 = buf(1:4)
        call upstr(buf4)
        if(buf4(1:4) == 'STOP') then
          close(nu_in)
          EXIT loop over data
        end if
        
        call RCF (ncol4data,buf(1:nc_buf),nc_buf,dum,
     :              ibgn,iend, ISTAT)
     
        if (dum /= ynull) then
          ndata = ndata + 1
          data(ndata) = dum
        end if
        
     
      END DO loop over data
        
      do i = 1, ndata
        work(i) = data(i)          
      end do

      call sort(ndata,work)
        
      do i = 1, ndata
        rank(i) = real(i)/real(ndata+1)
        data_theory(i) = invnorm(rank(i))          
      end do

      call moment(work,ndata,ave_work,adev,
     :            sdev_work,var,skew,curt)
     
      call moment(data_theory,ndata,ave_theory,adev,
     :            sdev_theory,var,skew,curt)
      
      
      
      write(nu_out,'(
     :  4x,a, 8x,a, 
     :  8x,a, 5x,a,
     :  7x,a, 4x,a
     :                         )') 
     :  'i', 'rank', 
     :  'data', 'invnorm', 
     :  'qdata', 'qinvnorm'
      
      do i= 1, ndata     
      
        write(nu_out,'(1x,i4, 5(1x,es11.4))') 
     :       i, rank(i), 
     :       work(i), data_theory(i), 
     :      (work(i)-ave_work)/sdev_work, 
     :       (data_theory(i)-ave_theory)/sdev_theory 
     
      end do
      
      close(nu_out)


!Sort on the mean_adjusted log stress and added a column of index and rank (index/(n+1)).  
!Then I  invnorm the probability for each ranked value.

! also compute quantiles

 
      end
      
      include '\forprogs\get_lun.for'
      include '\forprogs\skip.for'
      include '\forprogs\skipcmnt.for'
      include '\forprogs\moment.for'
      include '\forprogs\trim_c.for'
      include '\forprogs\upstr.for'
      include '\forprogs\rc_subs.for'
      include '\forprogs\invnorm.for'
      include '\forprogs\sort.for'
      
 
      