
!CHECK 0 as lower limit of array allocation--why?  It may have led to the error
! that seis(2048) not defined (before I set seis = 0.0 and when I compiled using
! the -chk switch).  I think that seis(0) then contains y(1) (from smcread) and seis(npts-1)
! contains y(npts).  

* -------------------------------------------------------------- smctsplt
      Program smctsplt

*!Control file for program SMCTSPlt
*!Stem name of ps files (max 40 characters)
* test_taper_
*!ntraces/plot (max 31, program will reset if needed):
* 2
*!start time, duration to plot (<=0 to start at 1st pt; >>= 0 to plot all):
* 0.0 900.0
*!peak-to-peak distance (cm) (ntraces*(p2p+0.5)<= 23.5, prog will reset if needed)
* 5.0
*!dpi:
* 200
*!File names printed to left ("l") or right("r"):
* l
*!Sign of time series:
* +1
*!Plot zero line (y/n):
*  y
*!gray scale (0.0, black, 1.0 white); line width (suggest 1.0)
*! these entries are needed even if the zero line is not plotted
* 0.5 1.0
*!Files to be plotted:
* 2261a_u.smc.f04_detrend_acc.a
*stop

*
* Note: if ntraces * (peak-to-peak distance + 0.5) > 23.5, then
* ntraces is reset to allow the proper number of traces per page.


* Dates: 09/04/00 - Written by D. Boore, based on my modification
*                   (multplt4.for) of C. Stephens' program.
*        09/13/00 - More work, including adding "showpage" in the case
*                   of a plot with fewer than ntraces_max traces 
*                   (so the ps file will print) and
*                   adding file names above each trace
*        09/14/00 - Read through a set to determine the max time and
*                   plot the times relative the max time
*        11/07/00 - Write label indicating acc, vel, dis, or unk
*        12/04/00 - "Control file for program smctsplt" added to control file
*        12/05/00 - Check for comp not specified
*        12/06/00 - Specify stem name of ps files in control file
*        12/27/00 - Increased format in write(* from i5 to i6 for ndata output)
*                 - Major change, using allocatable arrays and using smcread
*                   to read data, as well as redo scaling, etc.
*        12/28/00 - Added max time for plotting as input, and compute time
*                   such that the first point = 0.0 sec
*        02/02/01 - Changed name from smcmplot to smctsplt (because
*                   there will also be a smcrsplt)
*        03/19/01 - Used Chris Stephens' modification to do away with 
*                   upside-down plotting
*        05/03/01 - Add date, time to plot
*        06/04/01 - Add file name to plot
*        09/06/01 - Debugging problem when set tmax_in = 10.0 for a particular
*                   application.  It turns out that in some cases the points
*                   per cm can be smaller than the dots per cm, so that some 
*                   pixels will be empty.  The program does not allow for this.
*                   The easiest fix is to reset the dpi parameter.  I also
*                   dimension seis starting at 0.
*        10/19/01 - Obtain default name of control file via CR
*        11/08/01 - Reset pp_cm rather than ntraces if limit is exceeded; also
*                   increased ntraces_max_dimen to 31 (pp = 0.25 cm)
*        11/08/01 - Option to print file names to left or right
*        11/09/01 - Reset ntraces to max if exceeded
*        03/29/02 - Corrected error that showed up sporadically, having to do
*                   with exceeding number of points for a trace (used "ndata"
*                   rather than "npts(itrace)"
*        03/03/03 - Improve extraction of component plotted on right side.
*        03/11/03 - Corrected bug related to extracting vertical component
*        07/23/03 - Cleaned up some coding so could compile using LF95
*        10/31/03 - Add parameter to determine start time of plot
*        11/02/03 - Fixed bug involving number of points per trace (continuing
*                   the 03/29/02 fix).
*        11/26/03 - Max. length for stem is 20.
*                   Trim blanks from f_ps
*        11/27/03 - Fix problem that duration of plot is not set independently
*                   for each page.
*        04/06/04 - Scale each trace based on amplitude of portion being plotted
*        06/10/04 - Allow stem name of ps files to be up to 40 characters in 
*                   length
*        07/17/04 - Add sign of time series (so can plot with opposite polarity)
*        10/13/04 - Read only first 4 characters in looking for "STOP"
*                   so can add comment after "STOP" in control file
*        01/10/05 - Include gray zero line
*        07/25/05 - Allow more decimal places for max, min amp y-axis labels
*        07/25/05 - Can't get gray line debugged, so skip around
*        12/28/06 - Added zero tics to y axes
*        02/22/07 - Precede comments with ! so can read a variable number of
*                   comments before the parameters.
*        02/22/07 - Allow for the possibility of plotting a zero line
*        05/22/07 - Decrease maximum y-axis plot size to avoid clipping file information
*        07/16/07 - Add path to graph
*        10/12/07 - If smc file does not exist, quit rather than moving on to the next file.
*        10/16/07 - Transparent change to user needed because smcread can
*                   read two input formats.
*        12/09/08 - Allow for 999 output files.
*        12/11/08 - Correct bug related to resetting dpi for a given page and
*                   using that value for subsequent pages (actually, I should change the
*                   code so that different srates for the time series on a page are
*                   plotted with the appropriate dpi).
*        12/12/08 - Skip resetting of dpi
*        06/25/09 - Use get_date, get_time rather than datetime
*        11/16/09 - Increase length of input file name
*        03/09/10 - Allow for 1000 comments (for some reason, some files in the SSA folder
*                   for the ITSAK post 1999 data had over 800 comments).
!        03/13/10 - Increased length of output file names.

      character char_head(11)*80, comments(1000)*80, 
     :                            ctl_cmmnts(20)*79
      integer int_head(48)
      real real_head(50)
      
      parameter (ntraces_max_dimen=31)
      integer nc_f_smc(ntraces_max_dimen), 
     :        npts(ntraces_max_dimen)
      real sps(ntraces_max_dimen)

      character stacode*4, prnt_f_name_l_r*10
      character*30 stname
      character*5 comp, zero_line
      character*80 eqname
      character label*110, stem*100, date_c*10, time_c*11
      
      character f_ctl*80, buf*200, f_smc(ntraces_max_dimen)*200, 
     :          f_ps*140,  avdu_c*3, buf_path*220, buf_work*220
      logical f_ctl_exist, f_smc_exist

      real seis(:)
      allocatable :: seis

      parameter (XAXLEN=16.)	! length of x (time) axis, cm

      f_ctl_exist = .false.
      do while (.not. f_ctl_exist)
        f_ctl = ' '
        write(*, '(a\)') 
     :    ' Enter name of control file (cr=SMCTSPLT.CTL;'//
     :    ' ctl-brk to quit): '
        read(*, '(a)') f_ctl
        if (f_ctl(1:4) .eq. '    ') f_ctl = 'smctsplt.ctl'
        inquire(file=f_ctl, exist=f_ctl_exist)
        if (.not. f_ctl_exist) then
          write(*,'(a)') ' ******* FILE DOES NOT EXIST ******* '
        end if
      end do

      call get_lun(nu_ctl)
      open(unit=nu_ctl, file=f_ctl, status='unknown')

      call skipcmnt(nu_ctl,ctl_cmmnts, nc_ctl_cmmnts)
      stem = ' '
      read(nu_ctl,'(a)') stem
      call trim_c(stem,nc_stem)

      call skipcmnt(nu_ctl,ctl_cmmnts, nc_ctl_cmmnts)
      read(nu_ctl,*) ntraces_max
      
      call skipcmnt(nu_ctl,ctl_cmmnts, nc_ctl_cmmnts)
      read(nu_ctl,*) t_strt_in, t_plot_in
      
      call skipcmnt(nu_ctl,ctl_cmmnts, nc_ctl_cmmnts)
      read(nu_ctl,*) pp_cm
      
      call skipcmnt(nu_ctl,ctl_cmmnts, nc_ctl_cmmnts)
      read(nu_ctl,*) dpi_in
      
      call skipcmnt(nu_ctl,ctl_cmmnts, nc_ctl_cmmnts)
      prnt_f_name_l_r = ' '
      read(nu_ctl,'(a)') prnt_f_name_l_r      
      call trim_c(prnt_f_name_l_r, nc_pfnlr)
      call upstr(prnt_f_name_l_r)

      call skipcmnt(nu_ctl,ctl_cmmnts, nc_ctl_cmmnts)
      read(nu_ctl,*) sign_ts

      call skipcmnt(nu_ctl,ctl_cmmnts, nc_ctl_cmmnts)
      zero_line = ' '
      read(nu_ctl,'(a)') zero_line
      call trim_c(zero_line,nc_zero_line)
      call upstr(zero_line)
      
      call skipcmnt(nu_ctl,ctl_cmmnts, nc_ctl_cmmnts)
      read(nu_ctl,*) gray_scale, zero_line_width

      call skipcmnt(nu_ctl,ctl_cmmnts, nc_ctl_cmmnts)

      if (ntraces_max .gt. ntraces_max_dimen) then
        write(*, '(a)') ' ntraces_max > ntraces_max_dimen; '//
     :    ' resetting ntraces_max'
        ntraces_max = ntraces_max_dimen
      end if


      if (ntraces_max*(pp_cm+0.5) .gt. 21.0) then
        pp_cm = 21.0/float(ntraces_max) - 0.5
        write(*,'(a,1x,f5.2)') ' Resetting pp_cm to ', pp_cm
      end if 
      
* Read groups of ntraces:

      ngrp = 0

1234  continue                  ! read next group

* First, read a group of files and obtain tmax for each
      ntraces = 0
      t_plot = t_plot_in
      tmax = 0.0
      do while (ntraces + 1 .le. ntraces_max)
        buf = ' '
        read(nu_ctl,'(a)') buf
        call upstr(buf)
        call trim_c(buf,nchar_buf)
        if (buf(1:4) .eq. 'STOP') then   ! finished with plots
          if (ntraces .eq. 0) then       ! case when "stop" encountered
            close(nu_ctl)
            stop            
          else
            backspace nu_ctl  ! position before stop to exit nicely
            go to 4455                   ! the last set contains < ntraces_max
          end if
        end if

        ntraces = ntraces + 1

        f_smc(ntraces) = ' '
        f_smc(ntraces) = buf(1:nchar_buf)
        nc_f_smc(ntraces) = nchar_buf
        f_smc_exist = .false.
        inquire(file=f_smc(ntraces)(1:nchar_buf), exist=f_smc_exist)
        if (.not. f_smc_exist) then
          write(*, '(a)') 
     :      ' **** File '//f_smc(ntraces)(1:nc_f_smc(ntraces))//
     :      ' does not exist; QUITTING ***'
          close(nu_ctl)
          stop
        end if

        write(*,*)
        write(*,'(2a)') 
     :      ' Working on file ', f_smc(ntraces)(1:nchar_buf)
* Grab sps, npts, and compute tmax for the set
        call smc_nsps(f_smc(ntraces)(1:nchar_buf), 
     :                 npts(ntraces), sps(ntraces))
        write(*,'(a,1x,i6,1p2(1x,e10.3))') 
     :      ' npts, sps = ',
     :        npts(ntraces), sps(ntraces)
        if (float(npts(ntraces)-1)/sps(ntraces) .gt. tmax) 
     :        tmax = float(npts(ntraces)-1)/sps(ntraces)
      end do
4455  continue

      ngrp = ngrp + 1
      if(t_plot .gt. tmax) then
        t_plot = tmax
      end if

* See if have to reset dpi to make sure that have at least two samples per pixel
*   First find minimum sample rate for this group of traces:

      dpi = dpi_in
      sps_min = 10000.0
      do itrace = 1, ntraces
        if (sps(itrace) .lt. sps_min) then
          sps_min = sps(itrace)
        end if
      end do
*   Then check ptppx and reset dpi if needed:
      ptppx = (2.54/dpi) *(sps_min * t_plot)/xaxlen

!DEBUG
!
      iskip = 1
      if (iskip .eq. 0) then
!
!DEBUG
        if (ptppx .lt. 2.0) then
          dpi = aint((2.54/2.0) *(sps_min * t_plot)/xaxlen)
          ptppx = (2.54/dpi) *(sps_min * t_plot)/xaxlen
          write(*,*)
          write(*, '(a,1x,f5.1,a,1x,f5.1)') 
     :        '!!!!!!! Resetting dpi to ', dpi, ' so that ptppx = ',
     :                   ptppx
          write(*,*)
        end if
!DEBUG
!
      end if
!
!DEBUG

      dpc = dpi/2.54                   ! dots per cm
      lentic = nint(0.2*dpc)
      icm = nint(dpc)
      ipp_cmd2 = nint(0.5*pp_cm*dpc)
      ifntscale=nint(84.*dpi/600.)

      do itrace = 1, ntraces
        allocate( seis(0:npts(itrace)) )
        tskip = t_strt_in
!        tlength = 2000.0   ! 01/26/10
        tlength = t_plot_in ! 01/26/10

!DEBUG
        write(*,*)
        write(*,*) ' tskip, tlength, npts(itrace) = ', 
     :               tskip, tlength, npts(itrace)
!DEBUG

        seis = 0.0
        call SMCRead(f_smc(itrace)(1:nc_f_smc(itrace)), 
     :               tskip, tlength,
     :               seis, 
     :               char_head, int_head, real_head, comments)

!DEBUG
        write(*,*)
        write(*,*) ' npts(itrace), seis(1)= ', 
     :               npts(itrace), seis(1)
        write(*,*) ' npts(itrace), seis(npts(itrace))= ', 
     :               npts(itrace), seis(npts(itrace))
!DEBUG

* Read header info from smc file:
        if (index(char_head(1),'ACC') .ne. 0) then
          itype = 0
          avdu_c = 'ACC'
        else if (index(char_head(1),'VEL') .ne. 0) then
          itype = 1
          avdu_c = 'VEL'
        else if (index(char_head(1),'DIS') .ne. 0) then
          itype = 2
          avdu_c = 'DIS'
        else
          itype = 3
          avdu_c = 'UNK'
        endif

        write(*,'(2a)') ' avdu_c = ', avdu_c

        stacode = ' '
        stacode = char_head(3)(1:4)
        if (stacode .eq. ' ') stacode = 'none'
        eqname  = ' '
        eqname  = char_head(4)(27:80)
        if (eqname .eq. ' ') eqname = 'none'
        call left(eqname)
        stname  = ' '
        stname  = char_head(6)(11:40)
        if (stname .eq. ' ') stname = 'none'
        call left(stname)

        i_null  = int_head(1)

        iserial = int_head(8)
        ichan   = int_head(9)

        comp    = ' '
        if (int_head(13) .eq. i_null .or. int_head(13) .eq. 90) then ! horizontal
           if (int_head(14) .eq. i_null) then    ! undefined
             comp = 'none'
           else
             write(comp,'(i4)') int_head(14)
           end if
        else        ! vertical component
           if (int_head(13) .eq. i_null) then    ! undefined
             comp = 'none'
           else
             comp = 'vert'
           end if
        end if      

        ncom    = int_head(16)

! Do not need to fill an array with npts, sps because all plotting is 
! done in the loop over itrace

        ndata   = int_head(17)

        r_null  = real_head(1)

        srate   = real_head(2)

        if (float(ndata-1)/srate .gt. t_plot) then
          npts4plot = int(t_plot*srate) + 1
        else
          npts4plot = ndata
        end if

        write(*,*)
        write(*,'(a)') 
     :      ' itrace, srate, ndata, npts4plot, t_plot = '
        write(*,*) 
     :        itrace, srate, ndata, npts4plot, t_plot

        do i = 1, npts4plot
          seis(i) = sign_ts * seis(i)
        end do

        call mnmax(seis,1,npts4plot,1,smin,smax)

        if (itrace .eq. 1) then
* Get date, time:
          call get_date(date_c)
          call get_time(time_c)
* Construct name of ps file and open it:
          call get_lun(nu_ps)
          f_ps = ' '
          f_ps(1:nc_stem) = stem(1:nc_stem)
          write(f_ps(nc_stem+1:nc_stem+3),'(i3.3)') ngrp
          f_ps(nc_stem+4:nc_stem+6) = '.ps'
          call trim_c(f_ps,nc_f_ps)

          open(unit=nu_ps,file=f_ps(1:nc_f_ps),status='unknown')

* Write definitions etc to ps file:
          call header(nu_ps,DPI)

* Write eqname to top of plot:
          ix = nint(DPC*0.5*XAXLEN)
          iy = nint(DPC*0.5)
          write(nu_ps,'(i6," (",a,
     :      ") stringwidth pop 2 div sub",i6," M",
     :      " (",a,") show")')
     :      ix, eqname(:lastc(eqname)), iy, eqname(:lastc(eqname))

* Set up time axis, ticks, label at bottom:
          ix0 = 0
          iy0 = nint(-(ntraces*(pp_cm+0.5)+0.5)*DPC)
          write(nu_ps,'(2i6," M",i6," 0 r")') 
     :                               ix0, iy0, nint(XAXLEN*DPC)

          if (t_plot .le. 10.0) then
            tick_dt = 1.0
          else if (t_plot .le. 50.0) then
            tick_dt = 5.0
          else if (t_plot .le. 100.0) then
            tick_dt = 10.0
          else if (t_plot .le. 500.0) then
            tick_dt = 50.0
          else if (t_plot .le. 1000.0) then
            tick_dt = 100.0
          else if (t_plot .le. 5000.0) then
            tick_dt = 500.0
          else
            tick_dt = 1000.0
          end if

          ntics = t_plot/tick_dt + 1
          do itic = 1, ntics
            ix = nint((itic-1)*tick_dt*XAXLEN*DPC/t_plot)
            write(nu_ps,'(2i6," M 0",i4," r")') ix, iy0, lentic
            write(nu_ps,'("0 (",i5,") stringwidth pop 2 div neg",i5,
     :          " v (",i5,") show")')
     :          nint((itic-1)*tick_dt+t_strt_in), 
     :         -lentic-nint(0.1*DPC)-ifntscale, 
     :          nint((itic-1)*tick_dt+t_strt_in)
          end do

          write(nu_ps,'("S")')
          label = ' '
      	  write(label,'("TIME, s   (Duration =",f7.2,")")')
     :      t_plot
          write(nu_ps,'(i6," (",a,") stringwidth pop 2 div sub",i6,
     :      " M (",a,") show")')
     :      nint(0.5*XAXLEN*DPC), label(:lastc(label)),
     :      iy0 - nint(1.*DPC),
     :      label(:lastc(label))
     
          buf_path = ' '
          call get_path_from_system_call(buf_path, nc_buf_path)
          
          label = ' '
      	  label = 'Path:'//buf_path(14:nc_buf_path)
      	  print *, ' buf_path(14:nc_buf_path) = ', 
     :               buf_path(14:nc_buf_path) 
          
          write(nu_ps,'(i6," (",a,") stringwidth pop 2 div sub",i6,
     :      " M (",a,") show")')
     :      nint(0.5*XAXLEN*DPC), label(:lastc(label)),
     :      iy0 - nint(1.5*DPC),
     :      label(:lastc(label))
 
          label = ' '
      	  label = 'File:'//f_ps(1:nc_f_ps)//' -- Date:'//date_c//
     :            ' -- Time:'//time_c
          write(nu_ps,'(i6," (",a,") stringwidth pop 2 div sub",i6,
     :      " M (",a,") show")')
     :      nint(0.5*XAXLEN*DPC), label(:lastc(label)),
     :      iy0 - nint(2.0*DPC),
     :      label(:lastc(label))
        endif  ! end of writing of labels, now proceed to writing the time series

        iy0 = -nint(DPC*( float(itrace-1)*(pp_cm+0.5) + 0.5*pp_cm ))
      	  
        write(nu_ps,'(2i6," M")') 0, iy0
* Write smc file name:
        if (prnt_f_name_l_r(1:1) .eq. 'L') then

          write(nu_ps, '(2i6,a)')
     :     nint(2.0*lentic), 
     :     ipp_cmd2 - nint(1.5*real(lentic)),
     :     ' v ('//f_smc(itrace)(1:nc_f_smc(itrace))// 
     :     ') show'
        else if (prnt_f_name_l_r(1:1) .eq. 'R') then
          write(nu_ps, '(2i6,a)')
     :     nint(xaxlen*dpc)- nc_f_smc(itrace)*ifntscale - lentic/2, 
     :     ipp_cmd2 - nint(1.5*real(lentic)),
     :     ' v ('//f_smc(itrace)(1:nc_f_smc(itrace))//
     :     ') show'
        else
          write(*,'(a)') ' Error!!!, prnt_f_name_l_r = '//
     :        prnt_f_name_l_r(1:1)//'; invalid; quitting'
          stop
        end if


* Write type of motion:
        ix = nint(DPC*(-1.5))
        write(nu_ps,'(2i6," M 90 rotate")') ix, iy0
        write(nu_ps,
     :        '("(",a3,") stringwidth pop 2 div ",
     :          "neg 0 v ",
     :		"(",a3,") show -90 rotate")') AVDU_C, AVDU_C

* Write y-axis line and ticks on left side:
        write(nu_ps,'(2i6," M")') 0, iy0
        
        if (smin .lt. 0.0 .and. smax .gt. 0.0) then

* Write y-axis line and ticks on left side:
 
* y location of zero line, relative to top of left ordinate axis:
          i2zero = - int((smax/(smax-smin))*float(2*ipp_cmd2))
          
          i2bottom = - 2*ipp_cmd2 - i2zero
          write(nu_ps,'(2i5," v",
     :                  2i5," r",
     :                  2i5," r",
     :                  2i5," r",
     :                  2i5," r",
     :                  2i5," r",
     :                  2i5," r S")')
     :       -lentic, ipp_cmd2, 
     :        lentic, 0,
     :             0, i2zero,
     :       -lentic, 0,
     :        lentic, 0,
     :             0, i2bottom, 
     :       -lentic, 0
          
            
           if (zero_line(1:1) .eq. 'Y') then

* Write gray zero line:
* y location of zero line, relative to current origin iy0
             write(nu_ps,'(a)') '%'
             write(nu_ps,'(f5.2," newpen")') zero_line_width
             write(nu_ps,'(f5.2," setgray")') gray_scale
           
             write(nu_ps,'(2i6," M")') 0, iy0
             write(nu_ps,'(2i6," v")') 0, ipp_cmd2 ! do this rather than the more
! direct use of " 0 izero_from_iy0 v" because integer truncation caused a one pixel
! difference in the location of the tick mark and the zero line
             write(nu_ps,'(2i6," v")') 0, i2zero
             write(nu_ps,'(2i5, " r S")') nint(XAXLEN*DPC),0

             write(nu_ps,'("0.0 setgray")') 
             write(nu_ps,'("0.33 newpen")')      
             write(nu_ps,'(a)') '%'
 
           end if

 
         
        else  
        
          write(nu_ps,'(2i5," v",2i5," r",2i5," r",2i5," r S")')
     :     -lentic,ipp_cmd2, lentic,0, 0,-2*ipp_cmd2, -lentic,0
     
        end if

* Label y axis with max, min amplitudes:
        if (abs(smax) .ge. 0.1) then
          write(nu_ps,'(i4,"(",f7.1," ) stringwidth pop sub",
     :        i6," M (",f7.1,") show")')
     :        -lentic, smax, iy0+ipp_cmd2-ifntscale/4, smax
        else if (abs(smax) .ge. 0.01) then
          write(nu_ps,'(i4,"(",f7.2," ) stringwidth pop sub",
     :        i6," M (",f7.2,") show")')
     :        -lentic, smax, iy0+ipp_cmd2-ifntscale/4, smax
        else if (abs(smax) .ge. 0.001) then
          write(nu_ps,'(i4,"(",f7.3," ) stringwidth pop sub",
     :        i6," M (",f7.3,") show")')
     :        -lentic, smax, iy0+ipp_cmd2-ifntscale/4, smax
        else
          write(nu_ps,'(i4,"(",f7.4," ) stringwidth pop sub",
     :        i6," M (",f7.4,") show")')
     :        -lentic, smax, iy0+ipp_cmd2-ifntscale/4, smax
        endif

        if (abs(smin) .ge. 0.1) then
          write(nu_ps,'(i4,"(",f7.1," ) stringwidth pop sub",
     :        i6," M (",f7.1,") show")')
     :        -lentic, smin, iy0-ipp_cmd2-ifntscale/4, smin
        else if (abs(smin) .ge. 0.01) then
          write(nu_ps,'(i4,"(",f7.2," ) stringwidth pop sub",
     :        i6," M (",f7.2,") show")')
     :        -lentic, smin, iy0-ipp_cmd2-ifntscale/4, smin
        else if (abs(smin) .ge. 0.001) then
          write(nu_ps,'(i4,"(",f7.3," ) stringwidth pop sub",
     :        i6," M (",f7.3,") show")')
     :        -lentic, smin, iy0-ipp_cmd2-ifntscale/4, smin
        else
          write(nu_ps,'(i4,"(",f7.4," ) stringwidth pop sub",
     :        i6," M (",f7.4,") show")')
     :        -lentic, smin, iy0-ipp_cmd2-ifntscale/4, smin
        endif

        if (smin .lt. 0.0 .and. smax .gt. 0.0) then
          
          idown1 = - int((smax/(smax-smin))*float(2*ipp_cmd2))
          idown2 = - 2*ipp_cmd2 - idown1
          zero_label = 0.0
          write(nu_ps,'(i4,"(",f7.1," ) stringwidth pop sub",
     :        i6," M (",f7.1,") show")')
     :        -lentic, zero_label, 
     :        iy0+ipp_cmd2+idown1-ifntscale/4, zero_label
     
        end if



* Write y-axis line and ticks on right side:
        write(nu_ps,'(2i6," M")') nint(XAXLEN*DPC), iy0

        if (smin .lt. 0.0 .and. smax .gt. 0.0) then
          
          idown1 = - int((smax/(smax-smin))*float(2*ipp_cmd2))
          idown2 = - 2*ipp_cmd2 - idown1
          write(nu_ps,'(2i5," v",2i5," r",
     :                  2i5," r",
     :                  2i5," r",
     :                  2i5," r",
     :                  2i5," r",
     :                  2i5," r S")')
     :     lentic,ipp_cmd2, -lentic,0,
     :          0, idown1,
     :     lentic, 0,
     :    -lentic, 0,
     :          0,idown2, 
     :     lentic,0


        else
        
          write(nu_ps,'(2i5," v",2i5," r",2i5," r",2i5," r S")')
     :      lentic,ipp_cmd2, -lentic,0, 0,-2*ipp_cmd2, lentic,0
     
        end if


* Write component info on right side:
        ix = lentic+nint(DPC*XAXLEN)
        iy = iy0 + 0.5*ipp_cmd2
        write(nu_ps,'(2i6, " M (",a,") show")') 
     :        ix, iy, comp(:lastc(comp))

* Code to draw bars between min and max values of all data points within a
* pixel

! ratio of plotted duration to t_plot
        xlencm = ((float(npts4plot)/srate)/t_plot)*xaxlen 
        ptppx = float(npts4plot)/(xlencm*dpc)
        xlast = 0
        xend = ptppx
        ipixel = 1

        yscal = (pp_cm/(smax-smin))* dpc
        xscal = XLENcm*DPC/npts4plot
        scenter = 0.5*(smax+smin)

        i = 0
        ymin = seis(1)
        ymax = seis(1)

        do while (i+1 .lt. npts4plot)  ! change made 1/02/03
          i = i + 1
          x = float(i)
          if (x .lt. xend) then
* Find min, max y value for the x values within one x pixel:
            if (seis(i) .gt. ymax) then
              ymax = seis(i)
            else if (seis(i) .lt. ymin) then
              ymin = seis(i)
            endif             
          else                              ! stepped out of this x-pixel range
* Write bar:
            ix = nint( 0.5*(xlast+xend) * xscal )
            iymin = nint( (ymin - scenter) * yscal )
            iymax = nint( (ymax - scenter) * yscal )
            write(nu_ps,'( 2i6, " M", 2i6, " r")')
     :        ix,iy0 + iymin, 0,iymax - iymin

* Reset for next x-pixel:            
            xlast = xend
            ipixel = ipixel + 1
            xend = ipixel * ptppx
            ymin = seis(i-1)
            ymax = ymin
            if (seis(i) .gt. ymax) then
              ymax = seis(i)
            else if (seis(i) .lt. ymin) then
              ymin = seis(i)
            endif             
          end if
        end do

! commented out on 01/26/10
!        ix = nint(0.5*(xlast+xend)*xscal)
!        iymin = nint( (ymin - scenter) * yscal )
!        iymax = nint( (ymax - scenter) * yscal )
!        write(nu_ps,'( 2i6, " M", 2i6, " r")')
!     :        ix,iy0 + iymin, 0,iymax - iymin


        write(nu_ps,'("S")')

        deallocate(seis)

      enddo  ! loop over traces for this group

      write(*,'(2a)') ' Writing output file = ', f_ps(1:nc_f_ps)
      write(nu_ps,'("showpage")')

      close(nu_ps)

      goto 1234

      end
* -------------------------------------------------------------- smctsplt

* -------------------------------------------------------------- begin header
	subroutine header(luno,dpi)
* Dates: 09/03/00 - The size in the font spec was changed by D. Boore

	integer luno	! logical output unit
	real*4 dpi	! plotter dpi

	idpi = nint(dpi)
        ifntscale=nint(84.*dpi/600.)
        s_line = dpi/600.0
        
	write(luno,'(
     :      "%!"/
     :      "72",i6," div dup scale"/
     :      "1 setlinecap"/
     :      "1 setlinejoin"/
     :      "userdict /picstr 2 string put"/
     :      "/M /moveto load def"/
     :      "/v /rmoveto load def"/
     :      "/L /lineto load def"/
     :      "/r /rlineto load def"/
     :      "/S /stroke load def"/
     :      "/A /setgray load def"/
     :      "/C /setrgbcolor load def"/
     :      "/newpen /setlinewidth load def"/
     :      "%"/
     :      "% ------------------------------------------"/
     :       1x, f5.2, " newpen")') idpi, s_line
*     :      "1 newpen")') idpi
	write(luno,'(
     :      "1.25",i5," mul 10.0",i5," mul translate"/
     :      "/Helvetica findfont ",i2," scalefont setfont"/   
     :      "%")')  idpi, idpi, ifntscale

	return
	end
* -------------------------------------------------------------- end header


c -------------------------------------------------------------------  locase
	subroutine locase(string)

c  convert ascii string to lower case

	character*(*) string

        ioff = ichar('a') - ichar('A')

	i = 0
	do while (i .lt. len(string))
	  i = i + 1
	  if (string(i:i) .ge. 'A' .and. string(i:i) .le. 'Z')
     *		string(i:i) = char(ichar(string(i:i)) + ioff)
	enddo

	return

	end
c -------------------------------------------------------------------  locase

c -------------------------------------------------------------------  upcase
	subroutine upcase(string)

c  convert ascii string to upper case

	character*(*) string

	ioff = ichar('A') - ichar('a')

	i = 0
	do while (i .lt. len(string))
	  i = i + 1
	  if (string(i:i) .ge. 'a' .and. string(i:i) .le. 'z')
     *		string(i:i) = char(ichar(string(i:i)) + ioff)
	enddo

	return

	end
c -------------------------------------------------------------------  upcase

c -------------------------------------------------------------------  right
	subroutine right(string)

c  right-justify characters in ascii string

	character*(*) string

	lens = len(string)

	ie = lens
	do while (ie .gt. 0 .and. string(ie:ie) .eq. ' ')
	  ie = ie - 1
	enddo

	if (ie .eq. 0) return

	ishift = lens - ie
	i = lens
	j = i - ishift
	do while (i .gt. lens-ie)
	  string(i:i) = string(j:j)
	  i = i - 1
	  j = j - 1
	enddo
	do while (i .gt. 0)
	  string(i:i) = ' '
	  i = i - 1
	enddo

	return

	end
c -------------------------------------------------------------------  right

c -------------------------------------------------------------------  left
	subroutine left(string)

c  left-justify characters in ascii string

	character*(*) string

	lens = len(string)

	ib = 1
	do while (ib .le. lens .and. string(ib:ib) .eq. ' ')
	  ib = ib + 1
	enddo

	if (ib .eq. 1 .or. ib .gt. lens) return

	i = 1
	j = ib
	do while (i .lt. lens-ib+2)
	  string(i:i) = string(j:j)
	  i = i + 1
	  j = j + 1
	enddo
	do while (i .le. lens)
	  string(i:i) = ' '
	  i = i + 1
	enddo

	return

	end
c -------------------------------------------------------------------  left

c -------------------------------------------------------------------  lastc
	integer function lastc(string)

c  return position of last non-blank character in an ascii string
c  a value of 0 is returned for all blanks

	character*(*) string

	lastc = len(string)

	do while (lastc .gt. 0 .and. (string(lastc:lastc) .eq. ' ' 
     *		.or. string(lastc:lastc) .eq. '\0'))
	  lastc = lastc - 1
	enddo

	return

	end
c -------------------------------------------------------------------  lastc

c -------------------------------------------------------------------  iargs
	integer function iargs(string)

c  return the number of arguments in an ascii string.  arguments are delimited
c  by 'white' space (blanks or tabs) or by using commas.  single (') or double
c  (") quotes can be used to delimit contingous substrings that have embedded 
c  blanks or tabs (e.g. 'this example'); to preserve a single-quote character 
c  within a substring, use a double single-quote, (e.g. 'can''t' will be parsed 
c  as can't).

c  -1 is returned if an error is detected (e.g. format, missing quote delimiter)

	character*1 tab, quote, delim
	parameter (tab = char(9))
	parameter (quote = char(39))

	character*(*) string

	iargs = 0
	lens = len(string)
	ic = 0
	iarg = 0
	delim = ' '

c  -- begin main loop
	
	do while (ic .le. lens)

	  ib = ic + 1

c -- skip initial white space before argument

	  do while (ib .le. lens .and.
     *	 	(string(ib:ib) .eq. ' '	.or. string(ib:ib) .eq. tab))
	    ib = ib + 1
	  enddo

	  if (ib .gt. lens) then
	    if (delim .eq. ',') iargs = iargs + 1
	    return
	  endif

c -- implied argument (e.g. ',,').  not the same as null (ascii 0)!

	  if (string(ib:ib) .eq. ',') then
	    ic = ib

c -- quoted string using single-quote delimiter

	  else if (string(ib:ib) .eq. quote) then

	    ib = ib + 1
	    if (ib .gt. lens) go to 90
	    ic = ib
20	    do while (ic .le. lens .and.  string(ic:ic) .ne. quote)
	      ic = ic + 1
	    enddo
	    if (ic .gt. lens) go to 90
	    if (ic .lt. lens .and. string(ic+1:ic+1) .eq. quote) then
	      ic = ic + 2
	      if (ic .gt. lens) go to 90
	      go to 20
	    endif

	    if (ic .lt. lens) then
	      ic = ic + 1
              if (string(ic:ic) .ne. ' ' .and. string(ic:ic) .ne. tab
     *         .and. string(ic:ic) .ne. ',') go to 90
	    else
	      ic = ic + 1
	    endif
	
c -- quoted string using double-quote delimiter

	  else if (string(ib:ib) .eq. '"') then

	    ib = ib + 1
	    if (ib .gt. lens) go to 90
	    ic = ib

	    do while (ic .le. lens .and.  string(ic:ic) .ne. '"')
	      ic = ic + 1
	    enddo

	    if (ic .lt. lens) then
	      ic = ic + 1
              if (string(ic:ic) .ne. ' ' .and. string(ic:ic) .ne. tab
     *          .and. string(ic:ic) .ne. ',') go to 90

	    else if (ic .gt. lens) then
	      go to 90

	    else
	      ic = ic + 1
	    endif

c -- other string

	  else

	    ic = ib + 1
	    do while (ic .le. lens .and. string(ic:ic) .ne. ',' .and.
     *		string(ic:ic) .ne. ' ' .and. string(ic:ic) .ne. tab)
	      ic = ic + 1
	    enddo

	  endif

c -- found next argument

	  iargs = iargs + 1

c -- skip white space before delimiting comma or start of next argument

	  do while (ic .le. lens .and. (string(ic:ic) .eq. ' ' .or. 
     *		string(ic:ic) .eq. tab))
	    ic = ic + 1
	  enddo

	  if (ic .gt. lens) return

	  if (string(ic:ic) .ne. ',') ic = ic - 1

	  delim = string(ic:ic)

	enddo

	return

c -- error detected

90	iargs = -1

	return

	end
c -------------------------------------------------------------------  iargs

c -------------------------------------------------------------------  getstr
	subroutine getstr (narg, string, substr, nchar)

c  return the narg'th argument in an ascii string.  arguments are delimited
c  by 'white' space (blanks or tabs) or by using commas.  single (') or double
c  (") quotes can be used to delimit contingous substrings that have embedded 
c  blanks or tabs (e.g. 'this example'); to preserve a single-quote character 
c  within a substring, use a double single-quote, (e.g. 'can''t' will be parsed 
c  as can't).

c  on return, nchar = -1 if an error is detected (e.g. format, missing quote
c			 delimiter, length of target argument exceeds size of
c			 substr).  
c		    =  0 if narg exceeds the number of arguments in the
c			 search string
c                   =  index of last non-blank character in the argument, unless
c			 the argument is all blank, in which case substr is
c			 all blank characters and nchar = length of substr

c  the function iargs returns the number of arguments in an ascii string

c  cds 08-04-93

	character*1 tab, quote, delim
	parameter (tab = char(9))
	parameter (quote = char(39))

	character*(*) string	! search string
	character*(*) substr	! sub-string with target argument

	substr = ' '
	nchar = -1
	if (narg .lt. 1) return

	lens = len(string)
	ic = 0
	ie = 0
	iarg = 0
	delim = ' '

c  -- begin main loop
	
	do while (iarg .lt. narg .and. ic .le. lens)

	  ib = ic + 1
	  nchar = -1

c -- skip initial white space before argument

	  do while (ib .le. lens .and.
     *	 	(string(ib:ib) .eq. ' '	.or. string(ib:ib) .eq. tab))
	    ib = ib + 1
	  enddo

	  if (ib .gt. lens) then
	    if (delim .eq. ',' .or. iarg .eq. 0) then
	      iarg = iarg + 1
	      if (iarg .eq. narg) nchar = len(substr)
	    endif
	    return
	  endif

c -- implied argument (e.g. ',,').  not the same as null (ascii 0)!

	  if (string(ib:ib) .eq. ',') then
	    ic = ib
	    nchar = len(substr)

c -- quoted string using single-quote delimiter

	  else if (string(ib:ib) .eq. quote) then

	    ib = ib + 1
	    if (ib .gt. lens) return
	    ic = ib
20	    do while (ic .le. lens .and.  string(ic:ic) .ne. quote)
	      ic = ic + 1
	    enddo
	    if (ic .gt. lens) return
	    if (ic .lt. lens .and. string(ic+1:ic+1) .eq. quote) then
	      ic = ic + 2
	      if (ic .gt. lens) return
	      go to 20
	    endif

	    ie = ic - 1

	    if (ic .lt. lens) then
	      ic = ic + 1
              if (string(ic:ic) .ne. ' ' .and. string(ic:ic) .ne. tab 
     *          .and. string(ic:ic) .ne. ',') return
	    else
	      ic = ic + 1
	    endif
	
c -- quoted string using double-quote delimiter

	  else if (string(ib:ib) .eq. '"') then

	    ib = ib + 1
	    if (ib .gt. lens) return
	    ic = ib

	    do while (ic .le. lens .and.  string(ic:ic) .ne. '"')
	      ic = ic + 1
	    enddo

	    ie = ic - 1

	    if (ic .lt. lens) then
	      ic = ic + 1
	      if (string(ic:ic) .ne. ' ' .and. string(ic:ic) .ne. tab
     *         .and. string(ic:ic) .ne. ',') return

	    else if (ic .gt. lens) then
	      return

	    else
	      ic = ic + 1
	    endif

c -- other string

	  else

	    ic = ib + 1
	    do while (ic .le. lens .and. string(ic:ic) .ne. ',' .and.
     *		string(ic:ic) .ne. ' ' .and. string(ic:ic) .ne. tab)
	      ic = ic + 1
	    enddo

	    ie = ic - 1

	  endif

c -- found end of argument

	  iarg = iarg + 1

c -- is this the target?

	  if (iarg .eq. narg) then

	    if (nchar .gt. -1) then
	      return
	    else
	      nchar = ie - ib + 1
	      if (nchar .gt. len(substr)) then
		nchar = -1
	      else
		substr = string(ib:ie)
	      endif
	      return
	    endif

	  endif

c -- skip white space before delimiting comma or start of next argument

	  do while (ic .le. lens .and. (string(ic:ic) .eq. ' ' .or. 
     *		string(ic:ic) .eq. tab))
	    ic = ic + 1
	  enddo

	  if (ic .gt. lens) return

	  if (string(ic:ic) .ne. ',') ic = ic - 1

	  delim = string(ic:ic)

	enddo

	end
c -------------------------------------------------------------------  getstr


      include '\forprogs\get_lun.for'
      include '\forprogs\upstr.for'
      include '\forprogs\trim_c.for'
      include '\forprogs\skip.for'
      include '\forprogs\mnmax.for'
      include '\forprogs\smc_nsps.for'
      include '\forprogs\smcread.for'
      include '\forprogs\get_date.for'
      include '\forprogs\get_time.for'
      include '\forprogs\skipcmnt.for'
      include '\forprogs\get_path_from_system_call.for'

